﻿using System;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using SelectionChangedEventArgs=Telerik.Windows.Controls.SelectionChangedEventArgs;

namespace DatePickerNeedsDoubleClick
{
    public partial class MainPage : UserControl
    {
        private SimpleRow _currentRowRec = null;
        private ObservableCollection<SimpleRow> SimpleRowList = new ObservableCollection<SimpleRow>();

        public MainPage()
        {
            this.InitializeComponent();

            var trow1 = new SimpleRow();
            trow1.TRName = "Thomas";
            trow1.TRLohn = null;
            trow1.TRBG = 1000;
            trow1.TRZiv = 1;
            trow1.TRDate = DateTime.Now;
            trow1.TRInteger = 100;
            this.SimpleRowList.Add(trow1);
            var trow2 = new SimpleRow();
            trow2.TRName = "Rolf";
            trow2.TRLohn = 140000;
            trow2.TRBG = 500;
            trow2.TRZiv = 2;
            trow2.TRDate = null;
            trow2.TRInteger = 200;
            this.SimpleRowList.Add(trow2);
            var trow3 = new SimpleRow();
            trow3.TRName = "Marcel";
            trow3.TRLohn = 150000;
            trow3.TRBG = 1100;
            trow3.TRZiv = 3;
            trow3.TRDate = DateTime.Now;
            trow3.TRInteger = 300;
            this.SimpleRowList.Add(trow3);
            var trow4 = new SimpleRow();
            trow4.TRName = "Patricia";
            trow4.TRLohn = 160000;
            trow4.TRBG = 800;
            trow4.TRZiv = 4;
            trow4.TRDate = DateTime.Now;
            trow4.TRInteger = 400;
            this.SimpleRowList.Add(trow4);
            var trow5 = new SimpleRow();
            trow5.TRName = "Patricia";
            trow5.TRLohn = 150000;
            trow5.TRBG = 700;
            trow5.TRZiv = 5;
            trow5.TRDate = DateTime.Now;
            trow5.TRInteger = 500;
            this.SimpleRowList.Add(trow5);

            this.UIRadGrid.ItemsSource = this.SimpleRowList;
        }

        private void OnPickerLoaded(object sender, RoutedEventArgs e)
        {
            ((Control) sender).Focus();
        }

        private void UIRadDatePicker_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var rowrec = (sender as FrameworkElement).DataContext as SimpleRow;
            if (rowrec == null)
                rowrec = this._currentRowRec;
            if (rowrec != null)
                rowrec.TRDate = (sender as RadDatePicker).SelectedDate;
        }

        private void UIRadGrid_CellEditEnded(object sender, GridViewCellEditEndedEventArgs e)
        {
            this._currentRowRec = this.UIRadGrid.CurrentCell.ParentRow.DataContext as SimpleRow;
        }

        private void UIRadGrid_CurrentCellChanged(object sender, GridViewCurrentCellChangedEventArgs evt)
        {
            var template = this.LayoutRoot.Resources["UIDatePicker"] as DataTemplate;
            this.UIRadGrid.Columns[4].CellEditTemplate = template;
        }
    }

    public class SimpleRow
    {
        public Nullable<decimal> TRBG { get; set; }
        public Nullable<DateTime> TRDate { get; set; }
        public int TRInteger { get; set; }
        public Nullable<decimal> TRLohn { get; set; }
        public string TRName { get; set; }
        public short TRZiv { get; set; }
    }
}